#include <iostream>
using namespace std;

#define MAX 50

struct Produto {
    int id;
    int quant;
    float preco;
};

struct Fila {
    Produto v[MAX];
    int ini;
    int fim;
    int num;
};

int enfileirar(Fila &f, Produto p);
int desenfileirar(Fila &f, Produto &p);

int main(void) {
    // Declara e inicializa a fila
    Fila fila;
    fila.ini = 0;
    fila.fim = -1;
    fila.num = 0;

    // Produto temporrio para ser construdo e enfileirado
    Produto tmp;

    // L valores e os enfileira, se id for > 0
    do {
        cout << "Digite o cdigo do produto: (0 termina): ";
        cin >> tmp.id;
        if (tmp.id > 0) {

            cout << "Digite a quantidade do produto: ";
            cin >> tmp.quant;
            cout << "Digite o preco do produto: ";
            cin >> tmp.preco;

            enfileirar(fila, tmp);
            }
        } while(tmp.id > 0);

    // Agora mostra valores da fila at que eles acabem...
    while ( desenfileirar(fila, tmp) == 0 ) {
        cout << "*** Produto ***" << endl;
        cout << "    ID: " << tmp.id << endl;
        cout << "    Qt: " << tmp.quant << endl;
        cout << "    R$: " << tmp.preco << endl;
    }
}

// Enfileira um produto
// Entrada: f: fila             p: produto
// Retorna: 1- Se fila cheia    0- Caso contrrio
int enfileirar(Fila &f, Produto p) {
    // Se a fila est cheia... retorna 1
    if (f.num == MAX) return 1;
    // Se fila no est cheia, vamos enfileirar
    f.fim++;
    if (f.fim == MAX) f.fim = 0;
    f.v[f.fim] = p;
    f.num++;
    // Indica que valor foi enfileirado
    return 0;
}


// Desenfileira um produto
// Entrada: f: fila             p: produto para armazenar valor retirado da fila
// Retorna: 1- Se fila vazia    0- Caso contrrio
int desenfileirar(Fila &f, Produto &p) {
    // Se a fila est vazia... retorna 1
    if (f.num == 0) return 1;
    // Se fila no est vazia, vamos desenfileirar
    p = f.v[f.ini];
    f.ini++;
    if (f.ini == MAX) f.ini = 0;
    f.num--;
    // Indica que valor foi desenfileirado
    return 0;
}


